

	;Shifts the stream in the IStr register by the amount
	;given in R8. Uses the Res register as bit Reservoar,
	;Res_Count indicates the number of bits left in the
	;Reservoar
	
.start_profile shift_istream
shift_istream:
	sub		R8, Res_Count
	bra.n   get_packet
	str     R8, IStr
	sll     R8, Res
	ret
.end_profile shift_istream
get_packet:
	add		R8, Res_Count
	str		Res_Count, IStr
	ld.w	[IStr_Addr]+, Res
	sub     Res_Count, R8
	mov		0x10, Res_Count
	bra		shift_istream
	
;	
;.start_profile shift_istream	
;shift_istream:
;	sub		R8, Res_Count					;Check if there is enough bits left in R_Res
;	bra.n	get_packet					
;	movbf   Res[15:R8], R12  		    ;Extract bits R_Res
;	sll		R8, Res					;Shift out bits from R_Res
;	sll     R8, IStr					;Make room in R_IStr for bits from R_Res
;	or      R12, IStr					;Mask in bits in R_IStr from R_Res
;	ret									;Return from call
;.end_profile shift_istream
;get_packet:
;	add 	R8, Res_Count					;Calculate bits left in R_Res
;	movbf   Res[15:Res_Count], R12		;Extract the remaining bits from R_Res
;	sll		Res_Count, IStr				;Make room in R_IStr for bits from R_Res 
;	or		R12, IStr					;Mask in remaining bits
;	ld.w	[IStr_Addr]+, Res		;Load new bits to R_Res
;	sub		Res_Count,	R8				;Calculate bits left to stream in to R_Istr
;	mov		0x10,	Res_Count				;Reset R_Count to 16
;	bra		shift_istream 
;

	
;------------------------------------------------------------------------------------

	;Inserts a new node in the huffman tree. 
	;Next available address of tree structure in R6
	;Symbol in R7. Returns next available address in R6.

.start_profile insert_node	
insert_node:
	mov 	R6, 		R10
get_next:
	sub 	0x0006, 	R10			;Calcualte address to first field of last node in list
	ld.w 	[R10], 		R12			;Gets first field of last node in list
	tst 	LEAF, 		R12			;Make sure this is a leaf
	bra.eq 	get_next				;Get next if not
	and 	INT, 		R12			;Make internal
	st.w 	R12, 		[R10]+	 		;Store first field of new internal node
	sub 	(ROOT_ADDR+2), 	R10, 	R12		;Calc new parent address for leaf 
	or 	RIGHT_LEAF, 	R12			;Make rigth leaf
	st.w 	R12, 		[R6]			;Store first field of leaf in new location
	
	ld.w 	[R10], 		R11			;Get second field of old leaf (Count)
	sub 	ROOT_ADDR, 	R6, 	R8		;Calc abs right child addr
	st.w 	R11, 		[R6+2]			;Store new second field of leaf in new location
	
	ld.w 	[R10+2], 	R12			;Get third field of old leaf (symbol)
	
	insbf	R11[6:7],	R8[15]			;Insert LSB count
	st.w 	R8, 		[R10]+ 			;Store second field of new internal node
		
	st.w 	R12, 		[R6+4]			;Store third field of leaf in new location
	
	stin	R6,		[R12*+TABLE_ADDR]	;Store leaf address in symbol table
	add 	6, 		R6			;Next usable address in tree structure
	sub 	ROOT_ADDR, 	R6, 	R8		;Calc abs left child addr
	insbf	R11[13:7],	R8[15]			;Insert MSB count
	st.w 	R8, 		[R10]			;Store third field of new internal node
	
	stin	R6,		[R7*+TABLE_ADDR]	;Store leaf address in symbol table
	sub 	(ROOT_ADDR+4), 	R10			;Calc abs addr to parent
	or 	LEFT_LEAF, 	R10			;Make left leaf
	st.w 	R10, 		[R6]+			;Store first field
	st.w 	0x0000, 	[R6]+			;Store second field
	st.w 	R7, 		[R6]+			;Store third field
	ret
.end_profile insert_node
	
;------------------------------------------------------------------------------------------
	
	;Increments tree from leaf given by address in R6, to the root
	
.start_profile increment_tree	
increment_tree:
	;ld.w 	[R6+2], 	R7			;get count of leaf (moved to main function)
	add 	1, 		R7			;increment leaf
	st.w 	R7, 		[R6+2]			;Store incremented count
	call 	sort_tree				;Sort tree structure
	;ld.w 	[R6],	 	R9			;Get first field of current node (moved to sort_tree function)
extract_parent_addr:	
	addbf	ROOT_ADDR,	R9[:9]	
	ld.w 	[R9+0x4], 	R10			;get third field
	ld.w 	[R9+0x2], 	R12			;get second field
	slr 	2, 		R10,	R7		;extract count
	insbf	R12[15:7],	R7[6]
	add	1,		R7
	insbf	R7[6:7],	R12[15]			;insert count
	insbf	R7[13:7],	R10[15]
	st.w	R12,		[R9+0x2]		;store fields
	st.w	R10,		[R9+0x4]
	cmp 	ROOT_ADDR, 	R9			;check if root
	bra.eq 	end_increment_tree
	mov	R9,		R6
	call 	sort_tree			
	;ld.w 	[R6], 		R9			;Get first field of current node (moved to sort_tree function)
	bra 	extract_parent_addr
end_increment_tree:
	ret
.end_profile increment_tree

;----------------------------------------------------------------------------------------

	;Check if higher ordered nodes have lower frequency count
	;Count in R7, starting from address in R6. R6 is altered to 
	;new mem address for node if switched

.start_profile sort_tree	
sort_tree:
	ld.w 	[R6], 		R10			;Get first field of node
	mov 	R6, 		R9
	addbf	ROOT_ADDR,	R10[:9]			;Get parent address
next_sorted_node:
	sub 	0x06, 		R9			;Get address to higher sorted node			
	cmp	R9,		R10			;Is the higher sorted node its parent?
	bra.eq 	end_search				;Parent reached
	cmp	ROOT_ADDR,	R9
	bra.eq 	end_search				;Root reached
	ld.w 	[R9], 		R12			;Get first field of node
	ld.w 	[R9+0x2], 	R11			;get second field
	tst 	LEAF, 		R12			;Is this a leaf?
	bra.ne 	cont_next_sorted_node
	ld.w 	[R9+0x4], 	R12			;get third field
	slr 	9, 		R11
	insbf	R12[15:7],	R11[13]
cont_next_sorted_node:
	sub 	R7, 		R11			;Is the new count higher?
	bra.n 	next_sorted_node			;If it is, check next node
end_search:
	;mov 	R6, 		R7			;Mov original address to R7
	add 	0x06, 		R9,	R7		;Get address to found node
	cmp 	R7, 		R6			;Is it the same node
	bra.eq 	end_sort_tree
	call 	switch_nodes
	;mov	R7,		R6
end_sort_tree:
	ld.w 	[R7], 		R9
	ret
.end_profile sort_tree

;-----------------------------------------------------------------------------------------

	;Switch two nodes in tree, Address 1 in R6, Address 2 in R7
	;Will alter R9

.start_profile switch_nodes	
switch_nodes:	
	ld.w	[R6+0x2],	R11			;Get second field of node1
	ld.w	[R7+0x2],	R12			;Get second field of node2
	st.w	R11,		[R7+0x2]		;Store second field of node1 in new pos
	st.w	R12,		[R6+0x2]		;Store second field of node2 in new pos
	ld.w	[R6+0x4],	R11			;Get third field of node1
	ld.w	[R7+0x4],	R12			;Get third field of node2
	st.w	R11,		[R7+0x4]		;Store third field of node1 in new pos
	ld.w	[R6],		R9			;Get first field of node1
	st.w	R12,		[R6+0x4]		;Store third field of node2 in new pos
	
	tst 	0x0800, 	R9
	bra.ne leaf_node_1				;Is node1 a leaf node		
	addbf	ROOT_ADDR,	R11[:9]
	ld.w	[R11],		R10			;Get left child of node2
	sub	ROOT_ADDR,	R7,	R8		;Calc abs address of parent
	insbf	R10[15:7],	R8[15]
	ld.w	[R7+2], 	R10
	st.w	R8,		[R11]			;Store first field of left child
	
	addbf	ROOT_ADDR,	R10[:9]
	ld.w	[R10],		R11			;Get left child of node2
	insbf	R11[15:7],	R8[15]
	ld.w	[R7],		R11			;Get first field of node2
	st.w	R8,		[R10]			;Store first field of left child
	and 	0xF7FF,		R11,	R10		;Make internal
	st.w	R10,		[R7]
	bra 	node2
	
leaf_node_1:
	stin	R7,		[R11*+TABLE_ADDR]
	ld.w	[R7],		R11
	or 	0x0800,		R11,	R10		;Make leaf node
	st.w	R10,		[R7]
node2:
	tst 	0x0800, 	R11
	bra.ne leaf_node_2				;Is node2 a leaf node
	and 	0xF7FF,		R9			;Make internal
	st.w	R9,		[R6]
	addbf	ROOT_ADDR,	R12[:9]
	ld.w	[R12],		R10			;Get left child of node2
	sub	ROOT_ADDR,	R6,	R8		;Calc abs address of parent
	ld.w	[R6+2], 	R11
	insbf	R8[8:9],	R10[8]			;Insert new parent address
	addbf	ROOT_ADDR,	R11[:9]
	ld.w	[R11],		R9			;Get right child of node2
	st.w	R10,		[R12]			;Store first field of left child
	insbf	R8[8:9],	R9[8]			;Insert new parent address
	st.w	R9,		[R11]			;Store first field of right child
	;add	ROOT_ADDR,	R6
	bra	switch_nodes_ret
leaf_node_2:
	stin	R6,		[R12*+TABLE_ADDR]
	or	0x0800,		R9
	st.w	R9,		[R6]
switch_nodes_ret:
	ret
.end_profile	switch_nodes

;--------------------------------------------------------------------------------------


.start_profile decode
decode:
	xor 	R11, 		R11
decode_setup:
	xor 	R8, 		R8
	mov 	IStr, 		R12
cont_decode:
	tst 	0x8000, 	R12
	bra.eq 	left
	ld.w 	[R11+2+ROOT_ADDR], R11
	bra 	shift_enc_stream
left:	
	ld.w 	[R11+4+ROOT_ADDR], R11
shift_enc_stream:
	sll 	1, 		R12
	add 	1, 		R8
	and 	0x01FF, 	R11
	ld.w 	[R11+ROOT_ADDR],R10
	tst 	0x0010, 	R8
	bra.eq 	decode_get_addr
	call 	shift_istream
	xor 	R8, 		R8
	mov 	IStr, 		R12
decode_get_addr:
	tst 	0x0800, 	R10			;test if leaf node
	bra.ne 	decode_symbol		;if leaf, decode symbol
	bra 	cont_decode			
decode_symbol
	call 	shift_istream
	add 	ROOT_ADDR, 	R11,	R6
	ld.w 	[R6+4], 	R7
	ret
.end_profile decode
	
	

	


	
	
	