

	;Bit count R6, data R7, size R8

.start_profile shift_ostream streams
shift_ostream:
	ror		R8,			R7
	sub     R8,			Res_Count
	bra.n	store_ostream
	str		R8,			OStr
return_stream:
	ret
.end_profile shift_ostream
store_ostream
	add		R8,			Res_Count
	str		Res_Count,	OStr
	st.w	OStr,	[OStr_Addr]+
	sll		Res_Count,  R7
	sub		Res_Count,	R8
	str		R8,	OStr
	mov		0x10,		Res_Count
	sub		R8,			Res_Count
	bra     return_stream

	
;.start_profile shift_ostream streams
;shift_ostream
;	sub 	R8, 		Res_Count		;Check if there is room for incomming bits
;	bra.n 	store_OStr				;If not, store packet
;	sll 	R8, 		OStr			;Make room for incomming bits
;	or 	R7, 		OStr			;Mask in bits
;ret_shift_ostream:
;	ret
;.end_profile shift_ostream
;store_OStr
;	add	R8,		Res_Count		;Calc room left
;	ror	R8,		R7,	R12
;	insbf	R12[15:Res_Count], OStr[15]
;	rol	Res_Count,	OStr
;	st.w	OStr,		[OStr_Addr]+
;	mov	R7,		OStr
;	sub	Res_Count,	R8
;	mov	0x10,		Res_Count
;	sub	R8,		Res_Count
;	bra ret_shift_ostream
;	;ret
	
;------------------------------------------------------------------------------------

	;Inserts a new node in the huffman tree. 
	;Next available address of tree structure in R6
	;Symbol in R7. Returns next available address in R6.

.start_profile insert_node	
insert_node:
	mov 	R6, 		R10
get_next:
	sub 	0x0006, 	R10			;Calcualte address to first field of last node in list
	ld.w 	[R10], 		R12			;Gets first field of last node in list
	tst 	LEAF, 		R12			;Make sure this is a leaf
	bra.eq 	get_next				;Get next if not
	and 	INT, 		R12			;Make internal
	st.w 	R12, 		[R10]+	 		;Store first field of new internal node
	sub 	(ROOT_ADDR+2), 	R10, 	R12		;Calc new parent address for leaf 
	or 	RIGHT_LEAF, 	R12			;Make rigth leaf
	st.w 	R12, 		[R6]			;Store first field of leaf in new location
	
	ld.w 	[R10], 		R11			;Get second field of old leaf (Count)
	sub 	ROOT_ADDR, 	R6, 	R8		;Calc abs right child addr
	st.w 	R11, 		[R6+2]			;Store new second field of leaf in new location
	
	ld.w 	[R10+2], 	R12			;Get third field of old leaf (symbol)
	
	insbf	R11[6:7],	R8[15]			;Insert LSB count
	st.w 	R8, 		[R10]+ 			;Store second field of new internal node
		
	st.w 	R12, 		[R6+4]			;Store third field of leaf in new location
	
	stin	R6,		[R12*+TABLE_ADDR]	;Store leaf address in symbol table
	add 	6, 		R6			;Next usable address in tree structure
	sub 	ROOT_ADDR, 	R6, 	R8		;Calc abs left child addr
	insbf	R11[13:7],	R8[15]			;Insert MSB count
	st.w 	R8, 		[R10]			;Store third field of new internal node
	
	stin	R6,		[Res*+TABLE_ADDR]	;Store leaf address in symbol table
	sub 	(ROOT_ADDR+4), 	R10			;Calc abs addr to parent
	or 	LEFT_LEAF, 	R10			;Make left leaf
	st.w 	R10, 		[R6]+			;Store first field
	st.w 	0x0000, 	[R6]+			;Store second field
	st.w 	Res, 		[R6]+			;Store third field
	ret
.end_profile insert_node
	
;------------------------------------------------------------------------------------------
	
	;Increments tree from leaf given by address in R6, to the root
	
.start_profile increment_tree	
increment_tree:
	;ld.w 	[R6+2], 	R7			;get count of leaf (moved to main function)
	add 	1, 		R7			;increment leaf
	st.w 	R7, 		[R6+2]			;Store incremented count
	call 	sort_tree				;Sort tree structure
	;ld.w 	[R6],	 	R9			;Get first field of current node (moved to sort_tree function)
extract_parent_addr:	
	addbf	ROOT_ADDR,	R9[:9]	
	ld.w 	[R9+0x4], 	R10			;get third field
	ld.w 	[R9+0x2], 	R12			;get second field
	slr 	2, 		R10,	R7		;extract count
	insbf	R12[15:7],	R7[6]
	add	1,		R7
	insbf	R7[6:7],	R12[15]			;insert count
	insbf	R7[13:7],	R10[15]
	st.w	R12,		[R9+0x2]		;store fields
	st.w	R10,		[R9+0x4]
	cmp 	ROOT_ADDR, 	R9			;check if root
	bra.eq 	end_increment_tree
	mov	R9,		R6
	call 	sort_tree			
	;ld.w 	[R6], 		R9			;Get first field of current node (moved to sort_tree function)
	bra 	extract_parent_addr
end_increment_tree:
	ret
.end_profile increment_tree

;----------------------------------------------------------------------------------------

	;Check if higher ordered nodes have lower frequency count
	;Count in R7, starting from address in R6. R6 is altered to 
	;new mem address for node if switched

.start_profile sort_tree	
sort_tree:
	ld.w 	[R6], 		R10			;Get first field of node
	mov 	R6, 		R9
	addbf	ROOT_ADDR,	R10[:9]			;Get parent address
next_sorted_node:
	sub 	0x06, 		R9			;Get address to higher sorted node			
	cmp	R9,		R10			;Is the higher sorted node its parent?
	bra.eq 	end_search				;Parent reached
	cmp	ROOT_ADDR,	R9
	bra.eq 	end_search				;Root reached
	ld.w 	[R9], 		R12			;Get first field of node
	ld.w 	[R9+0x2], 	R11			;get second field
	tst 	LEAF, 		R12			;Is this a leaf?
	bra.ne 	cont_next_sorted_node
	ld.w 	[R9+0x4], 	R12			;get third field
	slr 	9, 		R11
	insbf	R12[15:7],	R11[13]
cont_next_sorted_node:
	sub 	R7, 		R11			;Is the new count higher?
	bra.n 	next_sorted_node			;If it is, check next node
end_search:
	;mov 	R6, 		R7			;Mov original address to R7
	add 	0x06, 		R9,	R7		;Get address to found node
	cmp 	R7, 		R6			;Is it the same node
	bra.eq 	end_sort_tree
	call 	switch_nodes
	;mov	R7,		R6
end_sort_tree:
	ld.w 	[R7], 		R9
	ret
.end_profile sort_tree

;-----------------------------------------------------------------------------------------

	;Switch two nodes in tree, Address 1 in R6, Address 2 in R7
	;Will alter R9

.start_profile switch_nodes	
switch_nodes:	
	ld.w	[R6+0x2],	R11			;Get second field of node1
	ld.w	[R7+0x2],	R12			;Get second field of node2
	st.w	R11,		[R7+0x2]		;Store second field of node1 in new pos
	st.w	R12,		[R6+0x2]		;Store second field of node2 in new pos
	ld.w	[R6+0x4],	R11			;Get third field of node1
	ld.w	[R7+0x4],	R12			;Get third field of node2
	st.w	R11,		[R7+0x4]		;Store third field of node1 in new pos
	ld.w	[R6],		R9			;Get first field of node1
	st.w	R12,		[R6+0x4]		;Store third field of node2 in new pos
	
	tst 	0x0800, 	R9
	bra.ne leaf_node_1				;Is node1 a leaf node		
	addbf	ROOT_ADDR,	R11[:9]
	ld.w	[R11],		R10			;Get left child of node2
	sub	ROOT_ADDR,	R7,	R8		;Calc abs address of parent
	insbf	R10[15:7],	R8[15]
	ld.w	[R7+2], 	R10
	st.w	R8,		[R11]			;Store first field of left child
	
	addbf	ROOT_ADDR,	R10[:9]
	ld.w	[R10],		R11			;Get left child of node2
	insbf	R11[15:7],	R8[15]
	ld.w	[R7],		R11			;Get first field of node2
	st.w	R8,		[R10]			;Store first field of left child
	and 	0xF7FF,		R11,	R10		;Make internal
	st.w	R10,		[R7]
	bra 	node2
	
leaf_node_1:
	stin	R7,		[R11*+TABLE_ADDR]
	ld.w	[R7],		R11
	or 	0x0800,		R11,	R10		;Make leaf node
	st.w	R10,		[R7]
node2:
	tst 	0x0800, 	R11
	bra.ne leaf_node_2				;Is node2 a leaf node
	and 	0xF7FF,		R9			;Make internal
	st.w	R9,		[R6]
	addbf	ROOT_ADDR,	R12[:9]
	ld.w	[R12],		R10			;Get left child of node2
	sub	ROOT_ADDR,	R6,	R8		;Calc abs address of parent
	ld.w	[R6+2], 	R11
	insbf	R8[8:9],	R10[8]			;Insert new parent address
	addbf	ROOT_ADDR,	R11[:9]
	ld.w	[R11],		R9			;Get right child of node2
	st.w	R10,		[R12]			;Store first field of left child
	insbf	R8[8:9],	R9[8]			;Insert new parent address
	st.w	R9,		[R11]			;Store first field of right child
	;add	ROOT_ADDR,	R6
	bra	switch_nodes_ret
leaf_node_2:
	stin	R6,		[R12*+TABLE_ADDR]
	or	0x0800,		R9
	st.w	R9,		[R6]
switch_nodes_ret:
	ret
.end_profile	switch_nodes

;--------------------------------------------------------------------------------------

.start_profile encode
encode:
	st.w 	R6, 		-[SP]
	xor 	R7, 		R7
	ld 	[R6], 		R6
	xor 	R8, 		R8
cont_encode:
	tst 	0x0200, 	R6			;test if Right child
	bra.ne 	encode_right_child
	tst 	0x0400, 	R6			;test if Left child
	bra.ne 	encode_left_child
	bra 	end_encode
encode_left_child:
	slr 	1, 		R7
	bra 	end_child
encode_right_child:
	slr 	1, 		R7
	or	0x8000, 	R7
end_child:
	add 	1, 		R8
	addbf	ROOT_ADDR,	R6[:9]
	ld 	[R6], 		R6
	bra 	cont_encode
end_encode
	rol 	R8, 		R7
	ld.w 	[SP]+, 		R6
	ret
.end_profile encode
	

	
	

	


	
	
	