
ADDR_CT 	.ASSIGN 0		;mem address to symbol table
ADDR_CT_END	.ASSIGN	512
ADDR_ST 	.ASSIGN 512		;mem address to code table
ADDR_ST_END	.ASSIGN	1024

ADDR_INN_STREAM	.ASSIGN 1024
ADDR_OUT_STREAM	.ASSIGN 2560

IStr_Addr	.ASSIGN R0
OUT_PTR		.ASSIGN R1
IStr		.ASSIGN R2
Res		.ASSIGN R3
Res_Count	.ASSIGN R4
K_COUNT		.ASSIGN	R5
K_ACC		.ASSIGN	R6	
SP		.ASSIGN R13
K_VALUE		.ASSIGN	R9


.nr_org 0x1000

	mov 	0xFFF, 		SP
	mov 	ADDR_INN_STREAM, IStr_Addr
	ld.w 	[IStr_Addr]+, 	IStr
	mov 	ADDR_OUT_STREAM, OUT_PTR
	ld.w 	[IStr_Addr]+, 	Res
	mov 	0x10, 		Res_Count
	mov	0x2,		K_VALUE
	mov	0x10,		K_COUNT
	mov	0x0,		K_ACC
	

decode:
	cmp 	(ADDR_OUT_STREAM+997), OUT_PTR
	bra.eq 	finish
	xor 	R7, 		R7

.start_profile decode
decode_loop:	
	clz	IStr,		R8
	tst 	0x10, 		R8
	bra.ne 	shift_stream
	add	R8,		R7
	add 	1, 		R8
	call 	shift_istream
	movbf   IStr[15:K_VALUE], R8
	sll     K_VALUE,    R7
	or      R8,         R7
	;insbf	IStr[15:K_VALUE], R7[15] 
	;rol	K_VALUE,	R7
	mov 	K_VALUE,	R8
	call	shift_istream
.end_profile decode
	add	R7,		K_ACC			;Accumulate code value
	sub	1,		K_COUNT			;Decrement code count
	ldin 	[R7*+ADDR_CT],	R11			;get freq and symbol
	bra.eq	calc_k
cont_comp_freq:
	movbf	R11[7:8],	R8[7]
	st.b 	R8, 		[OUT_PTR]+		;output decoded symbol
	addbf 	1, 		R11[8:]			;increment freq
	cmp	0x00FF,		R11
	bra.eq maintain_tables
cont_comp_freq_2:
	insbf	R11[7:8],	R8[15]
	stin 	R8, 		[R7*+ADDR_CT]		;store new freq in code table
	movbf	R8[7:8],	R10[7]
	insbf	R11[7:8],	R7[15]
	stin  	R7,		[R10*+ADDR_ST]
	
	
	;Freq and Code in R7
	;Freq and Smbl in R8
	;Smbl in R10
	;Freq in R11
	
.start_profile UpdTbl_compare update_table
comp_freq:
	tst 	0x00FF, 	R7			;code is zero
	bra.eq 	comp_freq_loop_ret			;No switch
	movbf 	R7[7:8],	R12[7]			;get code 
	sub 	1, 		R12			;get address to higher ordered code
	ldin 	[R12*+ADDR_CT],	R10			;get higher ordered freq
comp_freq_loop:
	slr	8,		R10
	cmp 	R11, 		R10
	bra.ges	comp_freq_loop_end			;if cmp freqs are equal
	cmp 	0, 		R12
	bra.eq 	comp_freq_loop_switch			;if top of table is reached
	sub 	1, 		R12			;get address to higher ordered code
	ldin 	[R12*+ADDR_CT],	R10			;get higher ordered freq
	bra 	comp_freq_loop
comp_freq_loop_end:
	add 	1, 		R12
comp_freq_loop_switch
	movbf	R7[7:8],	R11[7]			;get code
	cmp 	R11, 		R12			;cmp addresses
comp_freq_loop_ret:
	bra.eq 	decode			;If, equal, no switch
.end_profile UpdTbl_compare
	
	
	;Summary:
	;Freq and Code in R7
	;Freq and Smbl in R8
	;Code in R11
	;Found Code in R12
	
	
.start_profile UpdTbl_switch update_table	
switch:
	movbf	R8[7:8],	R10[7]
	insbf	R12[7:8],	R7[7]		;insert new code in Freq and Code
	stin	R7,		[R10*+ADDR_ST]	;Store new code and freq in smbl table
	ldin 	[R12*+ADDR_CT], R10		;get found smbl and freq
	stin	R8,		[R12*+ADDR_CT]  ;Store smbl and freq in new pos
	stin	R10,		[R11*+ADDR_CT]	;Store found smbl and freq in new pos
	movbf	R10[7:8],	R10[7]		;get found symbol
	ldin	[R10*+ADDR_ST],	R7		;get found code and freq
	stin	R8,		[R12*+ADDR_CT]  ;Store smbl and freq in new pos
	insbf	R11[7:8],	R7[7]		;insert new code in found freq and code
	stin	R7,		[R10*+ADDR_ST]	;Store new found freq and code
	bra 	decode
.end_profile UpdTbl_switch
	
shift_stream:
	add 	R8, 		R7
	call 	shift_istream
	bra 	decode_loop

.start_profile calc_k	
calc_k:
	slr	5,	K_ACC
	clz	K_ACC,	R12
	mov	0x10,	K_VALUE
	sub 	R12,	K_VALUE
	mov	0x0000,	K_ACC
	mov	0x10,	K_COUNT
	bra 	cont_comp_freq
.end_profile calc_k

maintain_tables:
	
	;symbol in R8
	;freq in R11
	;code in R7
.start_profile maintain_tables
	ld.w	[ADDR_CT],	R11			;get symbol and freq
	xor	R10,	R10
maintain_tables_loop:
	tst	0xFF00,		R11			;if freq is zero
	bra.eq  end_maintain_tables
	movbf	R11[7:8],	R12[7]	 		;get symbol
	slr	12,		R11	 		;Reduce freq
	sll	8,		R11
	insbf	R12[7:8],	R11[7] 			;insert symbol with reduced freq
	stin	R11,		[R10*+ADDR_CT]		;store reduced freq and symbol
	insbf	R10[7:8],	R11[7]			;insert code with reduced freq
	stin	R11,		[R12*+ADDR_ST]		;store reduced freq and code
	add	1,		R10
	cmp	0x0100,		R10
	ldin	[R10*+ADDR_CT],	R11			;get symbol and freq
	bra.n	maintain_tables_loop	
end_maintain_tables:
	mov	0xF,		R11
	bra	cont_comp_freq_2
.end_profile maintain_tables
	
.include "instr_dec.asm"

finish:
	xor R12, R12

.END
