	;Bit count OS_BCOUNT, data R7, size R8

.start_profile shift_ostream streams
shift_ostream
	sub 	R8, 		OS_BCOUNT		;Check if there is room for incomming bits
	bra.n 	store_OStr				;If not, store packet
	sll 	R8, 		OUT_REG			;Make room for incomming bits
	or 	R7, 		OUT_REG			;Mask in bits
ret_shift_ostream:
	ret
.end_profile shift_ostream
store_OStr
	add 	R8, 		OS_BCOUNT		;Calc room left
	sll 	OS_BCOUNT, 	OUT_REG			;Make room
	sub 	OS_BCOUNT, 	R8			;Fill up OStr
	slr 	R8, 		R7, 	R12			
	or 	R12, 		OUT_REG
	sll 	R8, 		R12			;Delete bit shifted in
	xor 	R7, 		R12, 	R11
	st.w 	OUT_REG, 	[OUT_PTR]+		;Store OStr
	xor	OUT_REG, 	OUT_REG			;Delete contents in register
	or 	R11, 		OUT_REG			;Mask in remaining bits
	mov 	0x10, 		OS_BCOUNT
	sub 	R8, 		OS_BCOUNT		;Calc free space in OStr
	bra 	ret_shift_ostream



.start_profile crc1
crc1:	
	mov 	0x3, 		R10
	xor 	R11, 		R11			;--crc 8
crc_loop:
	ld.b 	[R7]+, 		R12
	;slr 	8, 		R8, 	R11		;--crc 16
	xor 	R12, 		R11
	sll 	1, 		R11
	ld.w 	[R11+LUT], 	R11
	;sll 	8, 		R8			;--crc 16
	;xor 	R11, 		R8			;--crc 16
	sub 	1, 		R10
	bra.ne 	crc_loop
	;dbra 	1, 		R10
	mov 	R11, 		R8			;--crc 8
	ret
.end_profile crc1



.start_profile control_match	
check_match:
	xor 	R9, 		R9			;clear count reg
check_match_loop:
	add 	0x1, 		R9			;Increment
	ld.b 	[R7]+, 		R10			;load from look-ahead buffer
	ld.b 	[R8]+, 		R11			;load from search buffer (match)
	cmp	150,		R9
	bra.eq	finish_check_match
	cmp	END_INN_STREAM,	R7
	bra.eq 	finish_check_match
	cmp	STREAM_PTR,	R8
	bra.eq 	finish_check_match
	cmp 	R10, 		R11			;If equal
	bra.eq 	check_match_loop
finish_check_match:
	sub 	0x1, 		R9			;Subtract one
	ret 
.end_profile control_match
	
	
.start_profile add_match	
add_match:
;.start_profile	sa3_add_match1	shift_add3
	sll 	1, 		R9
	ld.w 	[R9+HASH_TABLE],R10
;.end_profile	sa3_add_match1
	st.w 	R8, 		[R9+HASH_TABLE]
	st.w 	R7, 		[R8]+
	st.w 	R10, 		[R8]+
	ret
.end_profile add_match

	
.start_profile make_code
enc_stream:
	
	tst 0xFFFF, R6			;If count is zero, no match found
	bra.ne length
	
new_char:
	ld.b [STREAM_PTR], R5
	or 	0x0700, R5,	R7
	mov 	11,	R8
	bra end_enc_stream

length:
	sub	R5,	STREAM_PTR, R7
	cmp	256,	R7
	bra.ges	add_pre_dist_10_bit
	xor	R7,	R7
cont_length:
	cmp	7,	R6
	bra.n	length_2_bit
	cmp	23,	R6
	bra.n	length_4_bit
	sub	23,	R6, 	R11
	or	0x2,	R7
.start_profile	bfo1_make_code2	bfo1
	sll	7,	R7
	or	R11,	R7
.end_profile	bfo1_make_code2
	mov	10,	R8
	bra	dist
length_2_bit
	sub	3,	R6,	R11
.start_profile	bfo1_make_code3	bfo1
	sll	2,	R7
	or	R11,	R7
.end_profile	bfo1_make_code3
	mov	5,	R8
	bra	dist
length_4_bit
	sub	7,	R6,	R11
	or	1,	R7
.start_profile	bfo1_make_code4	bfo1
	sll	4,	R7
	or 	R11,	R7
.end_profile	bfo1_make_code4
	mov	7,	R8
dist:
	call	shift_ostream
	sub 	R5, 	STREAM_PTR, R7
	cmp	256,	R7
	bra.n	dist_8_bit
	mov	10,	R8
	bra 	end_enc_stream
dist_8_bit
	mov	8,	R8
end_enc_stream:
	call 	shift_ostream
	add	1,	STREAM_PTR
	ret
.end_profile make_code
	
add_pre_dist_10_bit:
	mov	4,	R7
	bra 	cont_length
		

	


	
	
	
	
	
	