ISTREAM		.ASSIGN 0		;0x0000
OSTREAM		.ASSIGN 5120		;0x0100
STACK_POINTER	.ASSIGN 8192		;0x0400
ROOT_ADDR	.ASSIGN 1024		;0x0400
TABLE_ADDR	.ASSIGN 4096		;0x1000

RIGHT_LEAF	.ASSIGN 2560		;0x0A00
LEFT_LEAF	.ASSIGN 3072		;0x0C00
RIGHT_INT	.ASSIGN 512		;0x0200
LEFT_INT	.ASSIGN 1024		;0x0400
LEAF		.ASSIGN 2048		;0x0800
INT		.ASSIGN 2047		;0x07FF
ADDR_MASK	.ASSIGN 511		;0x01FF
DEL_ADDR_MASK	.ASSIGN 65024		;0xFE00



IStr_Addr 	.ASSIGN R0
OStr_Addr 	.ASSIGN R1
IStr      	.ASSIGN R2
OStr	     	.ASSIGN R3
Res	    	.ASSIGN R4
Res_Count	.ASSIGN R5
SP		.ASSIGN R13

.nr_org 0x2000
	
	mov 	STACK_POINTER, 	SP
	st.w 	1000, 		-[SP]
	st.w 	0x10, 		-[SP]
	
	mov 	ROOT_ADDR, 	R0
	st.w 	0x0000, 	[R0]+
	st.w 	0x0006, 	[R0]+
	st.w 	0x000C, 	[R0]+
	
	st.w 	R0, 		[0x0100+TABLE_ADDR]
	st.w 	0x0A00, 	[R0]+
	st.w 	0x0001, 	[R0]+
	st.w 	0x0100, 	[R0]+
	
	st.w 	R0, 		[0x0110+TABLE_ADDR]
	st.w 	0x0C00, 	[R0]+
	st.w 	0x0001, 	[R0]+
	st.w 	0x0110, 	[R0]+
	
	st.w 	R0, 		-[SP]

	mov 	ISTREAM, 	IStr_Addr
	mov 	OSTREAM, 	OStr_Addr

	ld.w 	[IStr_Addr]+, 	IStr
	ld.w 	[IStr_Addr]+, 	Res
	mov 	0x10, 		Res_Count
	
start:	
	call 	decode				;calls the decode function, symbol returned in R7, address in R6
	cmp 	0x0110, 	R7 		;Check if a new symbol is encountered	
	bra.eq 	add_node			;If it is a node must be added
	st.b 	R7, 		[OStr_Addr]+	;If not, the decoded symbol is stored to the output stream
	call increment_tree			;increment and sort tree structure
	cmp 	(OSTREAM+1000), OStr_Addr	;Check if this was the last symbol
	bra.n start
	bra finish
	
	
add_node:
	slr 	0x8, 		IStr, 	R7	;Get symbol from IStr
	st.b 	R7, 		[OStr_Addr]+	;Store symbol to output stream
	ld.w 	[SP]+, 		R6		;Load next usable address in tree structure
	call 	insert_node			;Insert a node in tree structure
	st.w 	R6, 		-[SP]		;Store next usable address in tree structure
	sub 	0x6, 		R6		;Get address to first field of the new node
	call 	increment_tree			;Increment and sort tree structure
	mov 	0x8, 		R8		;Shift the innstream
	call 	shift_istream
	cmp 	(OSTREAM+1000), OStr_Addr	;Check if this was the last symbol
	bra.n 	start
	bra 	finish

.include "instr.asm"

finish:
	xor R12, R12
.END
	
	
	
	
	
	
	
	
	
	

