

	;Shifts the stream in the IStr register by the amount
	;given in R8. Uses the Res register as bit Reservoar,
	;Res_Count indicates the number of bits left in the
	;Reservoar

.start_profile shift_istream streams		
shift_istream: 
	sub 	R8, 		Res_Count		;Check if enough bits are available in reservoar
	bra.n 	get_packet				;If not get new packet
	sll 	R8, 		IStr			;Shift out bits according to R8 
	slr 	Res_Count, 	Res, 	R10		;Shift out bit from reservoar into R10
	or 	R10, 		IStr			;Mask in bits from reservoar
	sll 	Res_Count, 	R10			;Delete bits from reservoar
	xor 	R10, 		Res
	ret
.end_profile shift_istream
get_packet:
	add 	R8, 		Res_Count		;Calc bits left in reservoar
	sll 	Res_Count, 	IStr
	or 	Res, 		IStr
	ld.w 	[IStr_Addr]+, 	Res
	sub	Res_Count, 	R8			;Calc bits left to shift
	mov 	0x10, 		Res_Count
	bra 	shift_istream
	
;------------------------------------------------------------------------------------

	;Inserts a new node in the huffman tree. 
	;Next available address of tree structure in R6
	;Symbol in R7. Returns next available address in R6.

.start_profile insert_node	
insert_node:
	mov 	R6, 		R10
get_next:
	sub 	0x0006, 	R10			;Calcualte address to first field of last node in list
	ld.w 	[R10], 		R12			;Gets first field of last node in list
	tst 	LEAF, 		R12			;Make sure this is a leaf
	bra.eq 	get_next				;Get next if not
	and 	INT, 		R12			;Make internal
	st.w 	R12, 		[R10]+	 		;Store first field of new internal node
	sub 	(ROOT_ADDR+2), 	R10, 	R12		;Make new first field of old leaf 
	or 	RIGHT_LEAF, 	R12
	st.w 	R12, 		[R6]			;Store new first field of old leaf
.start_profile 	ms_insert_node0 	mem_switch
	ld.w 	[R10], 		R11			;Get second field of old leaf (Count)
	st.w 	R11, 		[R6+2]			;Store new second field of old leaf
.end_profile 	ms_insert_node0
	sub 	ROOT_ADDR, 	R6, 	R8		;Calc abs right child addr
.start_profile 	bfo1_insert_node1 	bfo1
	sll 	9, 		R11, 	R12		;Shift into right pos
	or 	R8, 		R12			;Make second field
.end_profile 	bfo1_insert_node1
	st.w 	R12, 		[R10]+ 			;Store second field of new internal node
.start_profile 	ms_insert_node1 	mem_switch	
	ld.w 	[R10], 		R12			;Get third field of old leaf (symbol)
	st.w 	R12, 		[R6+4]			;Store third field of old leaf in new location
.end_profile 	ms_insert_node1
.start_profile	sa2_insert_node1	shift_add2
	sll 	1, 		R12			;Store new address in leaf table
	st.w 	R6, 		[R12+TABLE_ADDR]
.end_profile	sa2_insert_node1
	add 	6, 		R6			;Next usable address in tree structure
.start_profile bfo2_insert_node2 bfo2
	and 	0xFF80, 	R11, 	R12		;Mask out LSB's of count from old leaf
	sll 	2, 		R12			;shift into right pos
.end_profile bfo2_insert_node2
	sub 	ROOT_ADDR, 	R6, 	R8		;Calc abs left child addr
	or 	R8, 		R12
	st.w 	R12, 		[R10]			;Store third field of new internal node
.start_profile	sa2_insert_node2	shift_add2
	sll 	1, 		R7, 	R12		;Make new node
	st.w 	R6, 		[R12+TABLE_ADDR]	;Store address to new node in leaf table
.end_profile	sa2_insert_node2
	sub 	(ROOT_ADDR+4), 	R10			;Calc abs addr to parent
	or 	LEFT_LEAF, 	R10			;Make first field
	st.w 	R10, 		[R6]+			;Store first field
	st.w 	0x0000, 	[R6]+			;Store second field
	st.w 	R7, 		[R6]+			;Store third field
	ret
.end_profile insert_node
	
;------------------------------------------------------------------------------------------
	
	;Increments tree from leaf given by address in R6, to the root
	
.start_profile increment_tree	
increment_tree:
	ld.w 	[R6+2], 	R7			;get count of leaf
	add 	1, 		R7			;increment leaf
	st.w 	R7, 		[R6+2]			;Store incremented count
	call 	sort_tree				;Sort tree structure
	ld.w 	[R6],	 	R6			;Get first field of current node
extract_parent_addr:	
.start_profile 	bfo9_increment_tree1 	bfo9
	and 	0x01FF, 	R6, 	R9
	add 	(ROOT_ADDR), 	R9			;get address to internal node first field
.end_profile 	bfo9_increment_tree1
	call 	ext_count				;extract count field from internal node
	add 	1, 		R7			;increment
	call 	ins_count				;insert count to internal node
	cmp 	ROOT_ADDR, 	R9			;check if root
	bra.eq 	end_increment_tree
	mov	R9,		R6
	call 	sort_tree			
	ld.w 	[R6], 		R6			;get first field
	bra 	extract_parent_addr
end_increment_tree:
	ret
.end_profile increment_tree

;----------------------------------------------------------------------------------------

	;Check if higher ordered nodes have lower frequency count
	;Count in R7, starting from address in R6. R6 is altered to 
	;new mem address for node if switched

.start_profile sort_tree	
sort_tree:
	mov 	R6, 		R9
	st.w 	R7, 		-[SP]			;Push original count
	ld.w 	[R9], 		R10			;Get first field of node
.start_profile 	bfo9_sort_tree1 	bfo9
	and 	0x1FF, 		R10			;Extract parent address
	add 	ROOT_ADDR, 	R10			;calc parent address
.end_profile 	bfo9_sort_tree1
	st.w 	R10, 		-[SP]			;Push parent address
next_sorted_node:
	sub 	0x06, 		R9			;Get address to higher sorted node			
	ld.w 	[SP], 		R10			;get parent address
	cmp	R9,		R10			;Is the higher sorted node its parent?
	bra.eq 	end_search				;Parent reached
	cmp	ROOT_ADDR,	R9
	bra.eq 	end_search				;Root reached
	ld.w 	[R9], 		R11			;Get first field of node
	tst 	LEAF, 		R11			;Is this a leaf?
	bra.ne 	get_leaf_count
	call 	ext_count				;Extract count from internal node
cont_next_sorted_node:
	ld.w 	[SP+2], 	R11			;Get count
	sub 	R11, 		R7			;Is the new count higher?
	bra.n 	next_sorted_node			;If it is, check next node
end_search:
	mov 	R6, 		R7			;Mov original address to R7
	add 	0x06, 		R9,	R6		;Get address to found node
	cmp 	R6, 		R7			;Is it the same node
	bra.eq 	end_sort_tree
	call 	switch_nodes
end_sort_tree:
	add 	0x4, 		SP			;reset SP
	ret
.end_profile sort_tree
get_leaf_count
	ld.w 	[R9+2], 	R7			;Get count from leaf
	bra 	cont_next_sorted_node

;--------------------------------------------------------------------------------
	
	;extract count field of internal node found at mem address in R9
	;Result in R7
	
ext_count:
	ld.w 	[R9+0x2], 	R12			;get second field
	;slr 	9, 		R12, 	R7
	ld.w 	[R9+0x4], 	R7			;get third field
.start_profile 	bfo2_ext_count1 	bfo2
	and 	0xFE00, 	R7
	slr 	2, 		R7
.end_profile	bfo2_ext_count1
.start_profile bfo1_ext_count2	bfo1
	slr	9,		R12
	or 	R12, 		R7
.end_profile bfo1_ext_count2
	ret
	
;----------------------------------------------------------------------------------------

	;inserts count from R7 to internal node found at mem address in R9
	
ins_count:
	
	ld.w 	[R9+0x2], 	R10			;Get second field
.start_profile bfo3_ins_count1 bfo3
	sll 	9, 		R7, 	R12		;shift in to pos
	and 	0x01FF, 	R10			;clear for new count
	or 	R12, 		R10			;Make second field
.end_profile bfo3_ins_count1
	st.w 	R10, 		[R9+0x2]		;Store second field
	ld.w 	[R9+0x4], 	R10			;Get third field
.start_profile bfo2_ins_count2 bfo2
	and 	0xFF80, 	R7, 	R11		;get MSB's of count
	sll 	2, 		R11			;shift in to pos
.end_profile bfo2_ins_count2
.start_profile bfo5_ins_count3	bfo5	
	and 	0x01FF, 	R10			;clear for new count
	or 	R11, 		R10			;Make third field
.end_profile bfo5_ins_count3
	st.w 	R10, 		[R9+0x4]		;Store third field
	ret
	
;--------------------------------------------------------------------------------------

	;Switch two nodes in tree, Address 1 in R6, Address 2 in R7
	;Will alter R9

.start_profile switch_nodes	
	;ld.w [R7], R9
switch_nodes:	
	ld.w 	[R6+2], 	R10			;Get second field of node1
	ld.w 	[R7+2], 	R11			;Get second field of node2
	ld.w 	[R6], 		R8			;Get first field of node1
	tst 	0x0800, 	R8
	bra.ne leaf_node_1
.start_profile	bfo9_switch_nodes1	bfo9
	and 	0x1FF, 		R10, 	R9		;get child address
	add 	ROOT_ADDR, 	R9
.end_profile	bfo9_switch_nodes1
	ld.w 	[R9], 		R12
	sub 	ROOT_ADDR, 	R7
.start_profile	bfo5_switch_nodes2	bfo5
	and 	0xFE00, 	R12			;delete old parent address
	or 	R7, 		R12			;mask in new parent address
.end_profile	bfo5_switch_nodes2
	add 	ROOT_ADDR, 	R7
	st.w 	R12, 		[R9]			;Store new child header		
	st.w	R10,		[R7+2]			;Store second field of node 1 in new pos
	ld.w 	[R6+4],		R10			;Get third field of node 1
.start_profile	bfo9_switch_nodes3	bfo9
	and 	0x1FF, 		R10, 	R9		;get child address
	add 	ROOT_ADDR, 	R9
.end_profile	bfo9_switch_nodes3
	ld.w 	[R9], 		R12
	sub 	ROOT_ADDR, 	R7
.start_profile	bfo5_switch_nodes4	bfo5
	and 	0xFE00, 	R12			;delete old parent address
	or 	R7, 		R12			;mask in new parent address
.end_profile	bfo5_switch_nodes4
	add 	ROOT_ADDR, 	R7
	st.w 	R12, 		[R9]			;Store new child header
	ld.w	[R7+4],		R12			;Get third field of node2
	st.w	R10,		[R7+4]			;Store third field of node1 in new pos		
	ld.w	[R7],		R9			;Get first field of node2
	and 	0xF7FF, 	R9, 	R10		;Make internal
	st.w	R10,		[R7]			;Store header of new pos for node1
node2:							;Node2: ff R9, sf R11, tf R12. Node1: ff R8
	st.w 	R11, 		[R6+2]			;Store second field of node2 in new pos
	st.w 	R12, 		[R6+4]			;Store third field of node2 in new pos
	tst 	0x0800,		R9
	bra.ne 	leaf_node_2
	and 	0xF7FF, 	R8
	st.w 	R8, 		[R6]			;Store header of new pos for node2
.start_profile	bfo9_switch_nodes5	bfo9
	and 	0x1FF,		R11
	add 	ROOT_ADDR,	R11
.end_profile	bfo9_switch_nodes5
	ld.w 	[R11],		R10			;Get header of child
	sub 	ROOT_ADDR, 	R6
.start_profile	bfo5_switch_nodes6	bfo5
	and 	0xFE00, 	R10			;delete old parent address
	or 	R6, 		R10			;mask in new parent address
.end_profile	bfo5_switch_nodes6
	add	ROOT_ADDR,	R6
	st.w 	R10, 		[R11]			;Store new header of child
.start_profile	bfo9_switch_nodes7	bfo9
	and 	0x1FF,		R12
	add 	ROOT_ADDR,	R12
.end_profile	bfo9_switch_nodes7
	ld.w 	[R12],		R10			;Get header of child
	sub 	ROOT_ADDR, 	R6
.start_profile	bfo5_switch_nodes8	bfo5
	and 	0xFE00, 	R10			;delete old parent address
	or 	R6, 		R10			;mask in new parent address
.end_profile	bfo5_switch_nodes8
	add	ROOT_ADDR,	R6
	st.w 	R10, 		[R12]			;Store new header of child
	bra end_switch
	
leaf_node_1:
	st.w 	R10, 		[R7+2]			;Store second field of node1 in new pos
	ld.w	[R7+4],		R12			;Get third field of node2
.start_profile	ms_switch_nodes1	mem_switch
	ld.w	[R6+4],		R10			;Get third field of node1
	st.w	R10,		[R7+4]			;Store third field of node 1 in new pos
.end_profile	ms_switch_nodes1
.start_profile	sa2_switch_nodes1	shift_add2
	sll	1,		R10
	st.w	R7,		[R10+TABLE_ADDR]
.end_profile	sa2_switch_nodes1
	ld	[R7],		R9			;Get header of node2
	or 	0x0800,		R9, 	R10		;Make internal
	st.w	R10,		[R7]
	bra 	node2
leaf_node_2:
	st.w	R11,		[R6+2]
	st.w	R12,		[R6+4]
.start_profile	sa2_switch_nodes2	shift_add2
	sll	1,		R12
	st.w	R6,		[R12+TABLE_ADDR]
.end_profile	sa2_switch_nodes2
	or	0x0800,		R8
	st.w	R8,		[R6]
end_switch:
	ret
.end_profile switch_nodes		
;--------------------------------------------------------------------------------------
;	returns symbol in R7, address in R6

.start_profile decode
decode:
	xor 	R11, 		R11
decode_setup:
	xor 	R8, 		R8
	mov 	IStr, 		R12
cont_decode:
	tst 	0x8000, 	R12
	bra.eq 	left
	ld.w 	[R11+2+ROOT_ADDR], R11
	bra 	shift_enc_stream
left:	
	ld.w 	[R11+4+ROOT_ADDR], R11
shift_enc_stream:
	sll 	1, 		R12
	add 	1, 		R8
	tst 	0x0010, 	R8
	bra.eq 	decode_get_addr
	st.w 	R11, 		-[SP]
	call 	shift_istream
	ld.w 	[SP]+, 		R11
	xor 	R8, 		R8
	mov 	IStr, 		R12
decode_get_addr:
	and 	0x01FF, 	R11
	ld.w 	[R11+ROOT_ADDR],R10
	tst 	0x0800, 	R10			;test if leaf node
	bra.ne 	decode_symbol		;if leaf, decode symbol
	bra 	cont_decode			
decode_symbol
	st.w 	R11, 		-[SP]
	call 	shift_istream
	ld.w 	[SP]+, 		R6
	add 	ROOT_ADDR, 	R6
	ld.w 	[R6+4], 	R7
	ret
.end_profile decode
	
	

	


	
	
	