
ADDR_CT 	.ASSIGN 0		;mem address to symbol table
ADDR_CT_END	.ASSIGN	512
ADDR_ST 	.ASSIGN 512		;mem address to code table
ADDR_ST_END	.ASSIGN	1024

ADDR_INN_STREAM	.ASSIGN 1024
ADDR_OUT_STREAM	.ASSIGN 2560

IStr_Addr	.ASSIGN R0
OUT_PTR		.ASSIGN R1
IStr		.ASSIGN R2
Res		.ASSIGN R3
Res_Count	.ASSIGN R4
SP		.ASSIGN R13
K_VALUE		.ASSIGN	R9


.nr_org 0x1000

	mov 	0xFFF, 		SP
	mov 	ADDR_INN_STREAM, IStr_Addr
	mov 	ADDR_OUT_STREAM, OUT_PTR
	ld.w 	[IStr_Addr]+, 	IStr
	ld.w 	[IStr_Addr]+, 	Res
	mov 	0x10, 		Res_Count
	mov	0x2,		K_VALUE
	st.w	0x0010,		-[SP]
	st.w	0x0000,		-[SP]
	




decode:
	cmp 	(ADDR_OUT_STREAM+997), OUT_PTR
	bra.eq 	finish
	xor 	R7, 		R7

.start_profile decode
decode_loop:	
	call 	clz1
	tst 	0x10, 		R8
	bra.ne 	shift_stream
	add 	1, 		R8
	call 	shift_istream
	mov 	0x10,		R8
	sub	K_VALUE,	R8
.start_profile	bfo7_decode1	bfo7
	slr	R8,		IStr,	R11
	sll	K_VALUE,	R7
	or	R11,		R7
.end_profile	bfo7_decode1	
	mov 	K_VALUE,	R8
	call	shift_istream
.end_profile decode
	ld.w	[SP]+,		R12			;Pop accumulated code value
	ld.w 	[SP]+,		R11			;Pop code count
	add	R7,		R12			;Accumulate code value
	sub	1,		R11 			;Decrement code count
	bra.eq	calc_k
cont_comp_freq:
	st.w	R11,		-[SP]
	st.w	R12,		-[SP]
.start_profile	sa1_comp_freq1	shift_add1
	sll 1, 	R7, 		R11
	add 	ADDR_CT, 	R11			;address to codetable in R11
.end_profile	sa1_comp_freq1	
	ld.w 	[R11], 		R6			;get freq and symbol
.start_profile bfo6_decode_loop1 bfo6
	slr 	8, 		R6, 	R5		;separate freq and symbol
	and 	0x00FF, 	R6			;freq in R6, symbol in R5
.end_profile bfo6_decode_loop1
	st.b 	R5, 		[OUT_PTR]+		;output decoded symbol
	add 	1, 		R6			;increment freq
	st.b 	R6, 		[R11]			;store new freq in code table
	cmp	0x0FF,		R6
	bra.eq	maintain_tables
cont_comp_freq2
.start_profile	sa4_comp_freq2	shift_add4
	sll 	1, 		R5, 	R12
	st.b 	R6, 		[R12 + ADDR_ST]		;store new freq in smbl table
.end_profile	sa4_comp_freq2
	
.start_profile UpdTbl_compare update_table
comp_freq:
	tst 	0xFFFF, 	R7			;code is zero
	bra.eq 	comp_freq_loop_ret			;No switch
	mov 	R11, 		R10			;save code address
comp_freq_loop:
	sub 	2, 		R11			;get address to higher ordered code
	ld.b 	[R11], 		R8			;get higher ordered freq
	cmp 	R6, 		R8
	bra.ges	comp_freq_loop_end			;if cmp freqs are equal
	cmp 	ADDR_CT, 	R11
	bra.eq 	comp_freq_loop_switch			;if top of table is reached
	bra 	comp_freq_loop
comp_freq_loop_end:
	add 	2, 		R11
comp_freq_loop_switch
	cmp 	R11, 		R10			;cmp addresses
comp_freq_loop_ret:
	bra.eq 	decode			;If, equal, no switch
.end_profile UpdTbl_compare
	
	
	;Summary:
	;R5  : current symbol
	;R6  : current freq
	;R7  : current code
	;R8  : found freq
	;R10 : current code address
	;R11 : found code address
	;R12 : shifted symbol value
.start_profile UpdTbl_switch update_table	
switch:
	;add 1, R11
	ld.w 	[R11], 		R8		;get found smbl and freq
	st.b 	R6, 		[R11]+		;store current freq in new pos
	st.b 	R5, 		[R11]		;store current smbl in new pos
.start_profile bfo6_switch1 bfo6	
	slr 	8, 		R8, 	R6	;sparate smbl and freq
	and 	0x00FF, 	R8 		;smbl in R6, freq in R8
.end_profile bfo6_switch1
	st.b 	R8, 		[R10]+		;store found freq in new pos
	st.b 	R6, 		[R10] 		;store found smbl in new pos
.start_profile	sa4_switch1	shift_add4
	sll 	1, 		R6
	st.b 	R7, 		[R6 + (ADDR_ST+1)]	;store new code for found smbl
.end_profile	sa4_switch1
	sub 	ADDR_CT, 	R11			;calc found code 
	slr 	1, 		R11
	st.b 	R11, 		[R12 + (ADDR_ST+1)]
	bra 	decode
.end_profile UpdTbl_switch
	
shift_stream:
	mov 	0x10, 		R8
	call 	shift_istream
	bra 	decode_loop

.start_profile calc_k
calc_k:
	slr	5,	R12
	call	clz2
	mov	0x10,	K_VALUE
	sub 	R11,	K_VALUE
	mov	0x0000,	R12
	mov	0x10,	R11
	bra 	cont_comp_freq
.end_profile calc_k
	
.start_profile maintain_tables
maintain_tables:
	st.w	R7,		-[SP]
	st.w	R5,		-[SP]
	mov	ADDR_CT,	R7
maintain_tables_loop:
	ld.w	[R7],		R6			;get frequency and symbol
.start_profile 	bfo6_maintain_tables1 bfo6
	slr 	8, 		R6, 	R5		;seperate frequency and symbol,
	and 	0x00FF, 	R6			;Freq in R6, symbol in R5
.end_profile 	bfo6_maintain_tables1
	cmp	0,		R6
	bra.eq	end_maintain_tables
	slr	4,		R6
	st.b	R6,		[R7]
.start_profile	sa5_maintain_tables1	shift_add5
	sll	1,		R5
	ld.b	[R5+ADDR_ST],	R6
.end_profile	sa5_maintain_tables1
	slr	4,		R6
	st.b	R6,		[R5+ADDR_ST]
	add	2,		R7
	cmp	ADDR_CT_END,	R7
	bra.n	maintain_tables_loop
end_maintain_tables
	ld.b 	[R11], 		R6			;get frequency for current symbol
	ld.w	[SP]+,		R5
	ld.w	[SP]+,		R7
	bra	cont_comp_freq2
.end_profile maintain_tables
	
.include "instr_dec.asm"

finish:
	xor R12, R12

.END
