
ADDR_CT 	.ASSIGN 0		;mem address to symbol table
ADDR_CT_END	.ASSIGN 512
ADDR_ST 	.ASSIGN 512		;mem address to code table
ADDR_ST_END	.ASSIGN 1024


ADDR_INN_STREAM	.ASSIGN 1024
ADDR_OUT_STREAM	.ASSIGN 2560	

IStr_Addr	.ASSIGN R0
OUT_PTR		.ASSIGN R1
IStr		.ASSIGN R2
OUT_REG		.ASSIGN R3
OS_BCOUNT	.ASSIGN R4
K_VALUE		.ASSIGN	R9
SP		.ASSIGN R13

.nr_org	0x1000

	mov 	0x10, 		 OS_BCOUNT
	mov 	ADDR_INN_STREAM, IStr_Addr
	mov 	ADDR_OUT_STREAM, OUT_PTR
	mov 	0xFFF, 		 SP
	st.w	0x0010,		-[SP]
	st.w	0x0000,		-[SP]
	mov	0x2,		K_VALUE	
	
get_byte:
	ld.b 	[IStr_Addr]+, 	IStr 
	cmp 	(ADDR_INN_STREAM+1000), IStr_Addr
	bra.eq 	finish
.start_profile	sa3_get_byte1	shift_add3
	sll 	1, 		IStr
	ld.w 	[IStr + ADDR_ST], R6			;get frequency and code
.end_profile	sa3_get_byte1
.start_profile bfo6_get_byte1 bfo6
	slr 	8, 		R6, 	R5		;seperate frequency and code,
	and 	0x00FF, 	R6			;Freq in R6, code in R5
.end_profile bfo6_get_byte1
	st.w 	R5, 		-[SP]			;Push code on stack
	add 	0x1, 		R6			;Inc freq
	st.b 	R6, 		[IStr + ADDR_ST]	;store new freq in smbl tbl
	cmp 	0x00FF, 	R6
	bra.eq 	maintain_tables
cont_encode:
.start_profile	sa4_encode1	shift_add4
	sll 	1, 		R5
	st.b 	R6, 		[R5 + ADDR_CT]		;store new freq in code tbl
.end_profile	sa4_encode1
	slr 	1, 		R5

	
.start_profile encode	
encode:
	xor 	R7, 		R7
	slr	K_VALUE,	R5,	R10
enc_loop:
	sub 	0x10, 		R10			;shift zeroes into output stream
	bra.n 	enc_loop_end
	mov 	0x10, 		R8
	call 	shift_ostream
	bra enc_loop
enc_loop_end:
	add 	0x11, 		R10, 	R8		;shift zeroes into output stream
	mov 	0x1,		R7
	call 	shift_ostream
.start_profile	bfo8_encode1	bfo8
	slr	K_VALUE,	R5,	R7
	sll	K_VALUE,	R7
	xor	R5,		R7
.end_profile	bfo8_encode1
	mov	K_VALUE,	R8
	call	shift_ostream
.end_profile encode


.start_profile UpdTbl_compare update_table	
comp_freq:
	ld.w 	[SP]+, 		R5			;Pop code value
	ld.w	[SP]+,		R12			;Pop accumulated code value
	ld.w 	[SP]+,		R11			;Pop code count
	add	R5,		R12			;Accumulate code value
	sub	1,		R11 			;Decrement code count
	bra.eq	calc_k
cont_comp_freq:
	st.w	R11,		-[SP]
	st.w	R12,		-[SP]
	tst 	0xFFFF, 	R5			;test if the code is zero (highest oredered)
	bra.eq 	ret_get_byte
.start_profile	sa1_comp_freq1	shift_add1
	sll 	1, 		R5
	add 	(ADDR_CT-2), 	R5, 	R7		;addr to higher ordered (code tbl)
.end_profile	sa1_comp_freq1
comp_freq_loop:
	ld.b 	[R7], 		R10			;get higher ordered freq
	cmp 	R6, 		R10			;Is compared freq equal	
	bra.ges	comp_freq_loop_end
	cmp 	ADDR_CT, 	R7			;Is top of code table reached
	bra.eq 	pre_switch 
	sub 	0x2, 		R7
	bra comp_freq_loop
comp_freq_loop_end:
	add 	0x2, 		R7
pre_switch:
	add 	ADDR_CT, 	R5, 	R11		;make addr to code table
	cmp 	R7, 		R11
ret_get_byte:
	bra.eq 	get_byte
.end_profile UpdTbl_compare

.start_profile UpdTbl_switch update_table	
switch:				;move lower ordered symbol
				;R11 holds code tbl addr for curr code			
				;R7 holds code tbl addr for found code
;.start_profile	ms_switch1	mem_switch
	ld.w 	[R7], 		R8			;get symbol and freq for found code
	st.w 	R8, 		[R11]			;store into new pos
;.end_profile	ms_switch1
	sub 	(ADDR_CT), 	R7, 	R12
	slr 	1, 		R12
	st.b 	R12, 		[IStr + (ADDR_ST + 1)]	;store new code for curr smbl
	st.b 	R6, 		[R7]+			;Store curr freq and symbol into new pos
	slr 	1, 		IStr
	st.b 	IStr, 		[R7]
	slr 	8, 		R8			;get found symbol
	slr 	1, 		R5
.start_profile	sa4_switch1	shift_add4
	sll 	1, 		R8
	st.b 	R5, 		[R8+(ADDR_ST+1)] 	;store new code for found symbol
.end_profile	sa4_switch1
	bra 	get_byte
.end_profile 	UpdTbl_switch

.start_profile	calc_k
calc_k:
	slr	5,		R12
	call	clz1
	mov	0x10,		K_VALUE
	sub 	R7,		K_VALUE
	mov	0x0000,		R12
	mov	0x10,		R11
	bra 	cont_comp_freq
.end_profile calc_k

.start_profile maintain_tables
maintain_tables:
	mov	ADDR_CT,	R7
maintain_tables_loop:
	ld.w	[R7],		R6			;get frequency and symbol
.start_profile 	bfo6_maintain_tables1 bfo6
	slr 	8, 		R6, 	R5		;seperate frequency and symbol,
	and 	0x00FF, 	R6			;Freq in R6, symbol in R5
.end_profile 	bfo6_maintain_tables1
	cmp	0,		R6
	bra.eq	end_maintain_tables
	slr	4,		R6
	st.b	R6,		[R7]
.start_profile	sa5_maintain_tables1	shift_add5
	sll	1,		R5
	ld.b	[R5+ADDR_ST],	R6
.end_profile	sa5_maintain_tables1
	slr	4,		R6
	st.b	R6,		[R5+ADDR_ST]
	add	2,		R7
	cmp	ADDR_CT_END,	R7
	bra.n	maintain_tables_loop
end_maintain_tables
	ld.b 	[IStr + ADDR_ST], R6			;get frequency for current symbol
	ld.w	[SP],		  R5
	bra	cont_encode
.end_profile maintain_tables
	
	




.include "instr_enc.asm"




finish:
	mov 	16,		R8
	call	shift_ostream
	xor R12, R12	

.END		


	
	


