
architecture rtl of nb_crc is

 signal NewCRC : data_word_type;
 signal D : std_ulogic_vector(7 downto 0);
 signal C : data_word_type;
begin  -- rtl

  CRC_RES <= NewCRC;
  D      <= SRC(7 downto 0);
  C      <= RS2;



  crc_calc : process (D, C)
  begin  -- process crc_calc

--CRC 8 bit input
    NewCRC(0) <= D(4) xor D(0) xor C(8) xor C(12);
    NewCRC(1) <= D(5) xor D(1) xor C(9) xor C(13);
    NewCRC(2) <= D(6) xor D(2) xor C(10) xor C(14);
    NewCRC(3) <= D(7) xor D(3) xor C(11) xor C(15);
    NewCRC(4) <= D(4) xor C(12);
    NewCRC(5) <= D(5) xor D(4) xor D(0) xor C(8) xor C(12) xor C(13);
    NewCRC(6) <= D(6) xor D(5) xor D(1) xor C(9) xor C(13) xor C(14);
    NewCRC(7) <= D(7) xor D(6) xor D(2) xor C(10) xor C(14) xor C(15);
    NewCRC(8) <= D(7) xor D(3) xor C(0) xor C(11) xor C(15);
    NewCRC(9) <= D(4) xor C(1) xor C(12);
    NewCRC(10) <= D(5) xor C(2) xor C(13);
    NewCRC(11) <= D(6) xor C(3) xor C(14);
    NewCRC(12) <= D(7) xor D(4) xor D(0) xor C(4) xor C(8) xor C(12) xor 
                  C(15);
    NewCRC(13) <= D(5) xor D(1) xor C(5) xor C(9) xor C(13);
    NewCRC(14) <= D(6) xor D(2) xor C(6) xor C(10) xor C(14);
    NewCRC(15) <= D(7) xor D(3) xor C(7) xor C(11) xor C(15);
    
--     CRC 16 bit input
--     NewCRC(0) <= D(12) xor D(11) xor D(8) xor D(4) xor D(0) xor C(0) xor 
--                  C(4) xor C(8) xor C(11) xor C(12);
--     NewCRC(1) <= D(13) xor D(12) xor D(9) xor D(5) xor D(1) xor C(1) xor 
--                  C(5) xor C(9) xor C(12) xor C(13);
--     NewCRC(2) <= D(14) xor D(13) xor D(10) xor D(6) xor D(2) xor C(2) xor 
--                  C(6) xor C(10) xor C(13) xor C(14);
--     NewCRC(3) <= D(15) xor D(14) xor D(11) xor D(7) xor D(3) xor C(3) xor 
--                  C(7) xor C(11) xor C(14) xor C(15);
--     NewCRC(4) <= D(15) xor D(12) xor D(8) xor D(4) xor C(4) xor C(8) xor 
--                  C(12) xor C(15);
--     NewCRC(5) <= D(13) xor D(12) xor D(11) xor D(9) xor D(8) xor D(5) xor 
--                  D(4) xor D(0) xor C(0) xor C(4) xor C(5) xor C(8) xor 
--                  C(9) xor C(11) xor C(12) xor C(13);
--     NewCRC(6) <= D(14) xor D(13) xor D(12) xor D(10) xor D(9) xor D(6) xor 
--                  D(5) xor D(1) xor C(1) xor C(5) xor C(6) xor C(9) xor 
--                  C(10) xor C(12) xor C(13) xor C(14);
--     NewCRC(7) <= D(15) xor D(14) xor D(13) xor D(11) xor D(10) xor D(7) xor 
--                  D(6) xor D(2) xor C(2) xor C(6) xor C(7) xor C(10) xor 
--                  C(11) xor C(13) xor C(14) xor C(15);
--     NewCRC(8) <= D(15) xor D(14) xor D(12) xor D(11) xor D(8) xor D(7) xor 
--                  D(3) xor C(3) xor C(7) xor C(8) xor C(11) xor C(12) xor 
--                  C(14) xor C(15);
--     NewCRC(9) <= D(15) xor D(13) xor D(12) xor D(9) xor D(8) xor D(4) xor 
--                  C(4) xor C(8) xor C(9) xor C(12) xor C(13) xor C(15);
--     NewCRC(10) <= D(14) xor D(13) xor D(10) xor D(9) xor D(5) xor C(5) xor 
--                   C(9) xor C(10) xor C(13) xor C(14);
--     NewCRC(11) <= D(15) xor D(14) xor D(11) xor D(10) xor D(6) xor C(6) xor 
--                   C(10) xor C(11) xor C(14) xor C(15);
--     NewCRC(12) <= D(15) xor D(8) xor D(7) xor D(4) xor D(0) xor C(0) xor 
--                   C(4) xor C(7) xor C(8) xor C(15);
--     NewCRC(13) <= D(9) xor D(8) xor D(5) xor D(1) xor C(1) xor C(5) xor 
--                   C(8) xor C(9);
--     NewCRC(14) <= D(10) xor D(9) xor D(6) xor D(2) xor C(2) xor C(6) xor 
--                   C(9) xor C(10);
--     NewCRC(15) <= D(11) xor D(10) xor D(7) xor D(3) xor C(3) xor C(7) xor 
--                   C(10) xor C(11);


  end process crc_calc;

end rtl;
