
architecture rtl of nb_mask is

  signal len : std_ulogic_vector(3 downto 0);

begin  -- rtl

 
  
  mask_select : process (SRC, MASK_CONTROL, len)
  begin  -- process mask_select

    if (MASK_CONTROL.len_sel = '1') then
      len <= SRC(3 downto 0);
    else
      len <= MASK_CONTROL.length;
    end if;
    
    case(len) is
    when "1111"   => MSB_MASK <= x"FFFE";
    when "1110"   => MSB_MASK <= x"FFFC";
    when "1101"   => MSB_MASK <= x"FFF8";
    when "1100"   => MSB_MASK <= x"FFF0";
    when "1011"   => MSB_MASK <= x"FFE0";
    when "1010"   => MSB_MASK <= x"FFC0";
    when "1001"   => MSB_MASK <= x"FF80";
    when "1000"   => MSB_MASK <= x"FF00";
    when "0111"   => MSB_MASK <= x"FE00";
    when "0110"   => MSB_MASK <= x"FC00";
    when "0101"   => MSB_MASK <= x"F800";
    when "0100"   => MSB_MASK <= x"F000";
    when "0011"   => MSB_MASK <= x"E000";
    when "0010"   => MSB_MASK <= x"C000";
    when "0001"   => MSB_MASK <= x"8000";
    when "0000"   => MSB_MASK <= x"0000";
    when others   => MSB_MASK <= x"0000";
  end case;
  
 case(len) is
    when "1111"   => LSB_MASK <= x"7FFF";
    when "1110"   => LSB_MASK <= x"3FFF";
    when "1101"   => LSB_MASK <= x"1FFF";
    when "1100"   => LSB_MASK <= x"0FFF";
    when "1011"   => LSB_MASK <= x"07FF";
    when "1010"   => LSB_MASK <= x"03FF";
    when "1001"   => LSB_MASK <= x"01FF";
    when "1000"   => LSB_MASK <= x"00FF";
    when "0111"   => LSB_MASK <= x"007F";
    when "0110"   => LSB_MASK <= x"003F";
    when "0101"   => LSB_MASK <= x"001F";
    when "0100"   => LSB_MASK <= x"000F";
    when "0011"   => LSB_MASK <= x"0007";
    when "0010"   => LSB_MASK <= x"0003";
    when "0001"   => LSB_MASK <= x"0001";
    when "0000"   => LSB_MASK <= x"FFFF";
    when others   => LSB_MASK <= x"0000";
  end case;


end process mask_select;



end rtl;
